'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x2, _x3, _x4) { var _again = true; _function: while (_again) { var object = _x2, property = _x3, receiver = _x4; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x2 = parent; _x3 = property; _x4 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _TreeNode = require('./TreeNode');

var _TreeNode2 = _interopRequireDefault(_TreeNode);

var _util = require('./util');

var splitPos = function splitPos(pos) {
  return pos.split('-');
};
var filterMin = function filterMin(arr) {
  var a = [];
  arr.forEach(function (item) {
    var b = a.filter(function (i) {
      return item.indexOf(i) === 0 && (item[i.length] === '-' || !item[i.length]);
    });
    if (!b.length) {
      a.push(item);
    }
  });
  return a;
};
// console.log(filterMin(['0-0','0-1', '0-10', '0-0-1', '0-1-1', '0-10-0']));

function noop() {}

var Tree = (function (_React$Component) {
  _inherits(Tree, _React$Component);

  function Tree(props) {
    var _this = this;

    _classCallCheck(this, Tree);

    _get(Object.getPrototypeOf(Tree.prototype), 'constructor', this).call(this, props);
    ['onKeyDown', 'onCheck'].forEach(function (m) {
      _this[m] = _this[m].bind(_this);
    });
    this.contextmenuKeys = [];

    this.state = {
      expandedKeys: this.getDefaultExpandedKeys(props),
      checkedKeys: this.getDefaultCheckedKeys(props),
      selectedKeys: this.getDefaultSelectedKeys(props),
      dragNodesKeys: '',
      dragOverNodeKey: '',
      dropNodeKey: ''
    };
  }

  _createClass(Tree, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _setState;

      var expandedKeys = this.getDefaultExpandedKeys(nextProps, true);
      var checkedKeys = this.getDefaultCheckedKeys(nextProps, true);
      var selectedKeys = this.getDefaultSelectedKeys(nextProps, true);
      this.setState((_setState = {}, _defineProperty(_setState, expandedKeys && 'expandedKeys', expandedKeys), _defineProperty(_setState, checkedKeys && 'checkedKeys', checkedKeys), _defineProperty(_setState, selectedKeys && 'selectedKeys', selectedKeys), _setState));
    }

    /*
    // ie8
    createDragElement(treeNode) {
      const props = this.props;
       // copy treeNode and it's childNodes, remove data-reactid attribute.
      let tn = treeNode.refs.selectHandle.cloneNode(true);
      [...tn.childNodes].forEach(child => {
        if (child.nodeType !== 1) {
          return;
        }
        child.removeAttribute('data-reactid');
      });
      tn.removeAttribute('data-reactid');
       // make element
      const li = document.createElement("li");
      li.className = treeNode.props.className || '';
      li.appendChild(tn);
      const ul = document.createElement("ul");
      ul.className = `${props.prefixCls}-dragUl ${classNames(props.className, props.prefixCls)}`;
      ul.appendChild(li);
       ul.setAttribute('draggable', 'true');
      this.refs.tree.parentNode.insertBefore(ul, this.refs.tree);
      ul.focus();
    }
    */
  }, {
    key: 'onDragStart',
    value: function onDragStart(e, treeNode) {
      // console.log(this.refs.tree.parentNode, treeNode.refs.selectHandle);
      // this.createDragElement(treeNode);
      this.dragNode = treeNode;
      this.dragNodesKeys = this.getDragNodes(treeNode);
      var st = {
        dragNodesKeys: this.dragNodesKeys
      };
      var expandedKeys = this.getExpandedKeys(treeNode, false);
      if (expandedKeys) {
        // Controlled expand, save and then reset
        this.getOriginExpandedKeys();
        // if ('expandedKeys' in this.props) {
        //   this._originExpandedKeys = [...this.state.expandedKeys];
        // }
        st.expandedKeys = expandedKeys;
      }
      this.setState(st);
      this.props.onTreeDragStart({
        event: e,
        node: treeNode
      });
    }
  }, {
    key: 'onDragEnterGap',
    value: function onDragEnterGap(e, treeNode) {
      // console.log(e.pageY, getOffset(treeNode.refs.selectHandle), treeNode.props.eventKey);
      var offsetTop = (0, _util.getOffset)(treeNode.refs.selectHandle).top;
      var offsetHeight = treeNode.refs.selectHandle.offsetHeight;
      var pageY = e.pageY;
      var gapHeight = 2;
      if (pageY > offsetTop + offsetHeight - gapHeight) {
        // console.log('enter gap');
        this.dropPos = 1;
        return 1;
      }
      if (pageY < offsetTop + gapHeight) {
        // console.log('ee');
        this.dropPos = -1;
        return -1;
      }
      // console.log('xx');
      this.dropPos = 0;
      return 0;
    }
  }, {
    key: 'onDragEnter',
    value: function onDragEnter(e, treeNode) {
      var enterGap = this.onDragEnterGap(e, treeNode);
      if (this.dragNode.props.eventKey === treeNode.props.eventKey && enterGap === 0) {
        this.setState({
          dragOverNodeKey: ''
        });
        return;
      }
      // console.log('en...', this.dropPos);
      var st = {
        dragOverNodeKey: treeNode.props.eventKey
      };
      var expandedKeys = this.getExpandedKeys(treeNode, true);
      if (expandedKeys) {
        this.getOriginExpandedKeys();
        st.expandedKeys = expandedKeys;
      }
      this.setState(st);
      this.props.onTreeDragEnter({
        event: e,
        node: treeNode,
        expandedKeys: expandedKeys || this.state.expandedKeys
      });
    }
  }, {
    key: 'onDragOver',
    value: function onDragOver(e, treeNode) {
      this.props.onTreeDragOver({ event: e, node: treeNode });
    }
  }, {
    key: 'onDragLeave',
    value: function onDragLeave(e, treeNode) {
      this.props.onTreeDragLeave({ event: e, node: treeNode });
    }
  }, {
    key: 'onDrop',
    value: function onDrop(e, treeNode) {
      var key = treeNode.props.eventKey;
      if (this.dragNode.props.eventKey === key) {
        return;
      }
      var st = {
        dragOverNodeKey: '',
        dropNodeKey: key
      };
      this.setState(st);

      var posArr = treeNode.props.pos.split('-');
      var res = {
        event: e,
        node: treeNode,
        dragNode: this.dragNode,
        dragNodesKeys: this.dragNodesKeys,
        dropPos: this.dropPos + Number(posArr[posArr.length - 1])
      };
      if (this.dropPos !== 0) {
        res.dropToGap = true;
      }
      if ('expandedKeys' in this.props) {
        res.originExpandedKeys = this._originExpandedKeys || [].concat(_toConsumableArray(this.state.expandedKeys));
      }
      this.props.onTreeDrop(res);
    }
  }, {
    key: 'onExpand',
    value: function onExpand(treeNode) {
      var _this2 = this;

      var thisProps = this.props;
      var tnProps = treeNode.props;
      var expandedKeys = [].concat(_toConsumableArray(this.state.expandedKeys));
      var expanded = !tnProps.expanded;
      var index = expandedKeys.indexOf(tnProps.eventKey);
      if (expanded) {
        if (index === -1) {
          expandedKeys.push(tnProps.eventKey);
          if (thisProps.loadData) {
            return thisProps.loadData(treeNode).then(function () {
              _this2.setState({
                expandedKeys: expandedKeys
              });
            })['catch'](function () {
              // console.error('Something went wrong', reason);
            });
          }
        }
      } else {
          expandedKeys.splice(index, 1);
        }
      if (!('expandedKeys' in this.props)) {
        this.setState({ expandedKeys: expandedKeys });
      }
      thisProps.onExpand(treeNode, expanded, expandedKeys);
    }
  }, {
    key: 'onCheck',
    value: function onCheck(treeNode) {
      var _this3 = this;

      var tnProps = treeNode.props;
      var checked = !tnProps.checked;
      if (tnProps.checkPart) {
        checked = true;
      }
      var pos = undefined;
      Object.keys(this.treeNodesStates).forEach(function (item) {
        var itemObj = _this3.treeNodesStates[item];
        if (itemObj.key === (treeNode.key || tnProps.eventKey)) {
          pos = item;
          itemObj.checked = checked;
          itemObj.checkPart = false;
        }
      });
      this.handleCheckState(this.treeNodesStates, [pos], !checked);
      var checkKeys = this.getCheckKeys();
      this.checkPartKeys = checkKeys.checkPartKeys;
      var checkedKeys = checkKeys.checkedKeys;
      var newSt = {
        event: 'check',
        node: treeNode,
        allCheckedNodes: checkKeys.checkedNodes
      };
      if (!('checkedKeys' in this.props)) {
        this.setState({
          checkedKeys: checkedKeys
        });
        newSt.checked = checked;
      } else {
        checkedKeys = this.state.checkedKeys;
        newSt.allCheckedNodes = Object.keys(this.treeNodesStates).filter(function (item) {
          var itemObj = _this3.treeNodesStates[item];
          if (_this3.checkedKeys.indexOf(itemObj.key) !== -1) {
            return itemObj.node;
          }
        });
      }
      newSt.checkedKeys = checkedKeys;
      this.props.onCheck(newSt);
    }
  }, {
    key: 'onSelect',
    value: function onSelect(treeNode) {
      var props = this.props;
      var selectedKeys = [].concat(_toConsumableArray(this.state.selectedKeys));
      var eventKey = treeNode.props.eventKey;
      var index = selectedKeys.indexOf(eventKey);
      var selected = undefined;
      if (index !== -1) {
        selected = false;
        selectedKeys.splice(index, 1);
      } else {
        selected = true;
        if (!props.multiple) {
          selectedKeys.length = 0;
        }
        selectedKeys.push(eventKey);
      }
      var newSt = {
        event: 'select',
        node: treeNode
      };
      if (!('selectedKeys' in this.props)) {
        this.setState({
          selectedKeys: selectedKeys
        });
        newSt.selected = selected;
      } else {
        selectedKeys = this.state.selectedKeys;
      }
      newSt.selectedKeys = selectedKeys;
      props.onSelect(newSt);
    }
  }, {
    key: 'onMouseEnter',
    value: function onMouseEnter(e, treeNode) {
      this.props.onMouseEnter({ event: e, node: treeNode });
    }
  }, {
    key: 'onMouseLeave',
    value: function onMouseLeave(e, treeNode) {
      this.props.onMouseLeave({ event: e, node: treeNode });
    }
  }, {
    key: 'onContextMenu',
    value: function onContextMenu(e, treeNode) {
      var selectedKeys = [].concat(_toConsumableArray(this.state.selectedKeys));
      var eventKey = treeNode.props.eventKey;
      if (this.contextmenuKeys.indexOf(eventKey) === -1) {
        this.contextmenuKeys.push(eventKey);
      }
      this.contextmenuKeys.forEach(function (key) {
        var index = selectedKeys.indexOf(key);
        if (index !== -1) {
          selectedKeys.splice(index, 1);
        }
      });
      if (selectedKeys.indexOf(eventKey) === -1) {
        selectedKeys.push(eventKey);
      }
      this.setState({
        selectedKeys: selectedKeys
      });
      this.props.onRightClick({ event: e, node: treeNode });
    }

    // all keyboard events callbacks run from here at first
  }, {
    key: 'onKeyDown',
    value: function onKeyDown(e) {
      e.preventDefault();
    }
  }, {
    key: 'getDefaultExpandedKeys',
    value: function getDefaultExpandedKeys(props, willReceiveProps) {
      var defaultExpandedKeys = props.defaultExpandedKeys;
      if (props.defaultExpandAll) {
        defaultExpandedKeys = [];
        this.loopAllChildren(props.children, function (item, index, pos) {
          var key = item.key || pos;
          defaultExpandedKeys.push(key);
        });
      }
      var expandedKeys = willReceiveProps ? undefined : defaultExpandedKeys;
      if ('expandedKeys' in props) {
        expandedKeys = props.expandedKeys || [];
      }
      return expandedKeys;
    }
  }, {
    key: 'getDefaultCheckedKeys',
    value: function getDefaultCheckedKeys(props, willReceiveProps) {
      var checkedKeys = willReceiveProps ? undefined : props.defaultCheckedKeys;
      if ('checkedKeys' in props) {
        checkedKeys = props.checkedKeys || [];
      }
      return checkedKeys;
    }
  }, {
    key: 'getDefaultSelectedKeys',
    value: function getDefaultSelectedKeys(props, willReceiveProps) {
      var defaultSelectedKeys = props.multiple ? [].concat(_toConsumableArray(props.defaultSelectedKeys)) : [props.defaultSelectedKeys[0]];
      var selectedKeys = willReceiveProps ? undefined : defaultSelectedKeys;
      if ('selectedKeys' in props) {
        selectedKeys = props.multiple ? [].concat(_toConsumableArray(props.selectedKeys)) : [props.selectedKeys[0]];
      }
      return selectedKeys;
    }
  }, {
    key: 'getCheckKeys',
    value: function getCheckKeys() {
      var _this4 = this;

      var checkPartKeys = [];
      var checkedKeys = [];
      var checkedNodes = [];
      Object.keys(this.treeNodesStates).forEach(function (item) {
        var itemObj = _this4.treeNodesStates[item];
        if (itemObj.checked) {
          checkedKeys.push(itemObj.key);
          checkedNodes.push(itemObj.node);
        } else if (itemObj.checkPart) {
          checkPartKeys.push(itemObj.key);
        }
      });
      return {
        checkPartKeys: checkPartKeys, checkedKeys: checkedKeys, checkedNodes: checkedNodes
      };
    }
  }, {
    key: 'getOriginExpandedKeys',
    value: function getOriginExpandedKeys() {
      if (!this._originExpandedKeys && 'expandedKeys' in this.props) {
        this._originExpandedKeys = [].concat(_toConsumableArray(this.state.expandedKeys));
      }
    }
  }, {
    key: 'getOpenTransitionName',
    value: function getOpenTransitionName() {
      var props = this.props;
      var transitionName = props.openTransitionName;
      var animationName = props.openAnimation;
      if (!transitionName && typeof animationName === 'string') {
        transitionName = props.prefixCls + '-open-' + animationName;
      }
      return transitionName;
    }
  }, {
    key: 'getDragNodes',
    value: function getDragNodes(treeNode) {
      var _this5 = this;

      var dragNodesKeys = [];
      Object.keys(this.treeNodesStates).forEach(function (item) {
        if (item.indexOf(treeNode.props.pos) === 0) {
          dragNodesKeys.push(_this5.treeNodesStates[item].key);
        }
      });
      return dragNodesKeys;
    }
  }, {
    key: 'getExpandedKeys',
    value: function getExpandedKeys(treeNode, expand) {
      var key = treeNode.props.eventKey;
      var expandedKeys = this.state.expandedKeys;
      var expandedIndex = expandedKeys.indexOf(key);
      var exKeys = undefined;
      if (expandedIndex > -1 && !expand) {
        exKeys = [].concat(_toConsumableArray(expandedKeys));
        exKeys.splice(expandedIndex, 1);
        return exKeys;
      }
      if (expand && expandedKeys.indexOf(key) === -1) {
        return expandedKeys.concat([key]);
      }
    }
  }, {
    key: 'filterTreeNode',
    value: function filterTreeNode(treeNode) {
      var filterTreeNode = this.props.filterTreeNode;
      if (typeof filterTreeNode !== 'function' || treeNode.props.disabled) {
        return false;
      }
      return filterTreeNode.call(this, treeNode);
    }
  }, {
    key: 'handleCheckState',
    value: function handleCheckState(obj, checkedArr, unCheckEvent) {
      var evt = false;
      if (typeof unCheckEvent === 'boolean') {
        evt = true;
      }
      // stripTail('x-xx-sss-xx')
      var stripTail = function stripTail(str) {
        var arr = str.match(/(.+)(-[^-]+)$/);
        var st = '';
        if (arr && arr.length === 3) {
          st = arr[1];
        }
        return st;
      };
      checkedArr.forEach(function (_pos) {
        Object.keys(obj).forEach(function (i) {
          if (splitPos(i).length > splitPos(_pos).length && i.indexOf(_pos) === 0) {
            obj[i].checkPart = false;
            if (evt) {
              if (unCheckEvent) {
                obj[i].checked = false;
              } else {
                obj[i].checked = true;
              }
            } else {
              obj[i].checked = true;
            }
          }
        });
        var loop = function loop(__pos) {
          var _posLen = splitPos(__pos).length;
          if (_posLen <= 2) {
            return;
          }
          var sibling = 0;
          var siblingChecked = 0;
          var parentPos = stripTail(__pos);
          Object.keys(obj).forEach(function (i) {
            if (splitPos(i).length === _posLen && i.indexOf(parentPos) === 0) {
              sibling++;
              if (obj[i].checked) {
                siblingChecked++;
              } else if (obj[i].checkPart) {
                siblingChecked += 0.5;
              }
            }
          });
          var parent = obj[parentPos];
          // sibling 不会等于0
          // 全不选 - 全选 - 半选
          if (siblingChecked === 0) {
            parent.checked = false;
            parent.checkPart = false;
          } else if (siblingChecked === sibling) {
            parent.checked = true;
            parent.checkPart = false;
          } else {
            parent.checkPart = true;
            parent.checked = false;
          }
          loop(parentPos);
        };
        loop(_pos);
      });
    }
  }, {
    key: 'loopAllChildren',
    value: function loopAllChildren(childs, callback) {
      var loop = function loop(children, level) {
        _react2['default'].Children.forEach(children, function (item, index) {
          var pos = level + '-' + index;
          if (item.props.children && item.type === _TreeNode2['default']) {
            loop(item.props.children, pos);
          }
          callback(item, index, pos);
        });
      };
      loop(childs, 0);
    }
  }, {
    key: 'renderTreeNode',
    value: function renderTreeNode(child, index) {
      var level = arguments.length <= 2 || arguments[2] === undefined ? 0 : arguments[2];

      var pos = level + '-' + index;
      var key = child.key || pos;
      var state = this.state;
      var props = this.props;
      var cloneProps = {
        ref: 'treeNode-' + key,
        root: this,
        eventKey: key,
        pos: pos,
        loadData: props.loadData,
        onMouseEnter: props.onMouseEnter,
        onMouseLeave: props.onMouseLeave,
        onRightClick: props.onRightClick,
        prefixCls: props.prefixCls,
        showLine: props.showLine,
        showIcon: props.showIcon,
        checkable: props.checkable,
        draggable: props.draggable,
        dragOver: state.dragOverNodeKey === key && this.dropPos === 0,
        dragOverGapTop: state.dragOverNodeKey === key && this.dropPos === -1,
        dragOverGapBottom: state.dragOverNodeKey === key && this.dropPos === 1,
        expanded: state.expandedKeys.indexOf(key) !== -1,
        selected: state.selectedKeys.indexOf(key) !== -1,
        checked: this.checkedKeys.indexOf(key) !== -1,
        checkPart: this.checkPartKeys.indexOf(key) !== -1,
        openTransitionName: this.getOpenTransitionName(),
        openAnimation: props.openAnimation,
        filterTreeNode: this.filterTreeNode.bind(this)
      };
      return _react2['default'].cloneElement(child, cloneProps);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this6 = this;

      var props = this.props;
      var domProps = {
        className: (0, _classnames2['default'])(props.className, props.prefixCls),
        role: 'tree-node'
      };
      if (props.focusable) {
        domProps.tabIndex = '0';
        domProps.onKeyDown = this.onKeyDown;
      }
      // console.log(this.state.expandedKeys, this._originExpandedKeys, props.children);
      var checkedKeys = this.state.checkedKeys;
      var checkedPos = [];
      this.treeNodesStates = {};
      this.loopAllChildren(props.children, function (item, index, pos) {
        var key = item.key || pos;
        var checked = false;
        if (checkedKeys.indexOf(key) !== -1) {
          checked = true;
          checkedPos.push(pos);
        }
        _this6.treeNodesStates[pos] = {
          node: item,
          key: key,
          checked: checked,
          checkPart: false
        };
      });
      this.handleCheckState(this.treeNodesStates, filterMin(checkedPos.sort()));
      var checkKeys = this.getCheckKeys();
      this.checkPartKeys = checkKeys.checkPartKeys;
      this.checkedKeys = checkKeys.checkedKeys;

      return _react2['default'].createElement(
        'ul',
        _extends({}, domProps, { unselectable: true, ref: 'tree' }),
        _react2['default'].Children.map(props.children, this.renderTreeNode, this)
      );
    }
  }]);

  return Tree;
})(_react2['default'].Component);

Tree.propTypes = {
  prefixCls: _react.PropTypes.string,
  checkable: _react.PropTypes.oneOfType([_react.PropTypes.bool, _react.PropTypes.node]),
  multiple: _react.PropTypes.bool,
  showLine: _react.PropTypes.bool,
  showIcon: _react.PropTypes.bool,
  defaultExpandAll: _react.PropTypes.bool,
  defaultExpandedKeys: _react.PropTypes.arrayOf(_react.PropTypes.string),
  checkedKeys: _react.PropTypes.arrayOf(_react.PropTypes.string),
  defaultCheckedKeys: _react.PropTypes.arrayOf(_react.PropTypes.string),
  selectedKeys: _react.PropTypes.arrayOf(_react.PropTypes.string),
  defaultSelectedKeys: _react.PropTypes.arrayOf(_react.PropTypes.string),
  onExpand: _react.PropTypes.func,
  onCheck: _react.PropTypes.func,
  onSelect: _react.PropTypes.func,
  loadData: _react.PropTypes.func,
  onMouseEnter: _react.PropTypes.func,
  onMouseLeave: _react.PropTypes.func,
  onRightClick: _react.PropTypes.func,
  onTreeDragStart: _react.PropTypes.func,
  onTreeDragEnter: _react.PropTypes.func,
  onTreeDragOver: _react.PropTypes.func,
  onTreeDragLeave: _react.PropTypes.func,
  onTreeDrop: _react.PropTypes.func,
  filterTreeNode: _react.PropTypes.func,
  openTransitionName: _react.PropTypes.string,
  openAnimation: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.object])
};

Tree.defaultProps = {
  prefixCls: 'rc-tree',
  multiple: false,
  checkable: false,
  draggable: false,
  showLine: false,
  showIcon: true,
  defaultExpandAll: false,
  defaultExpandedKeys: [],
  defaultCheckedKeys: [],
  defaultSelectedKeys: [],
  onExpand: noop,
  onCheck: noop,
  onSelect: noop,
  onTreeDragStart: noop,
  onTreeDragEnter: noop,
  onTreeDragOver: noop,
  onTreeDragLeave: noop,
  onTreeDrop: noop
};

exports['default'] = Tree;
module.exports = exports['default'];